//----------------------------------------------------------------------//
//	WIC ֘A															//
//																		//
//----------------------------------------------------------------------//
#include <vcl.h>
#pragma hdrstop
#include <memory>
#include <utilcls.h>
#include "usr_wic.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)

//---------------------------------------------------------------------------
//t@Cw肵ނ̃rbg}bv擾
// img_type : default = WICIMG_PREVIEW;
//---------------------------------------------------------------------------
bool WIC_load_image(UnicodeString fnam, Graphics::TBitmap *o_bmp, int img_type)
{
	bool res = true;
	try {
		::CoInitialize(NULL);
		try {
			TComInterface<IWICImagingFactory>		factory;
			TComInterface<IWICBitmapDecoder>		decoder;
			TComInterface<IWICFormatConverter>		converter;
			TComInterface<IWICBitmapFrameDecode>	frame;
			TComInterface<IWICBitmapSource> 		preview;
			TComInterface<IWICBitmapSource>			thumbnail;

			if (FAILED(::CoCreateInstance(CLSID_WICImagingFactory, NULL,
				CLSCTX_INPROC_SERVER, IID_IWICImagingFactory, (LPVOID*)&factory)))
					Abort();

			if (FAILED(factory->CreateDecoderFromFilename(fnam.c_str(), NULL,
				GENERIC_READ, WICDecodeMetadataCacheOnDemand, &decoder)))
					Abort();

			if (FAILED(factory->CreateFormatConverter(&converter))) Abort();

			HRESULT res = S_FALSE;
			if (img_type==WICIMG_THUMBNAIL) {
				//TlC擾
				res = decoder->GetThumbnail(&thumbnail);
				if (res==S_OK && FAILED(converter->Initialize(thumbnail,
					GUID_WICPixelFormat24bppBGR, WICBitmapDitherTypeNone, NULL, 0.0f, WICBitmapPaletteTypeCustom)))
						Abort();
			}
			if (res!=S_OK || img_type==WICIMG_PREVIEW) {
				//vr[擾
				res = decoder->GetPreview(&preview);
				if (res==S_OK && FAILED(converter->Initialize(preview,
					GUID_WICPixelFormat24bppBGR, WICBitmapDitherTypeNone, NULL, 0.0f, WICBitmapPaletteTypeCustom)))
						Abort();
			}
			if (res!=S_OK) {
				//t[擾
				res = decoder->GetFrame(0, &frame);
				if (res==S_OK && FAILED(converter->Initialize(frame,
					GUID_WICPixelFormat24bppBGR, WICBitmapDitherTypeNone, NULL, 0.0f, WICBitmapPaletteTypeCustom)))
						Abort();
			}
			if (FAILED(res)) Abort();

			//TCY擾
			UINT i_wd, i_hi;
			if (FAILED(converter->GetSize(&i_wd, &i_hi))) Abort();
			//C[WɃRs[
			UINT stride = i_wd * 3;
			std::unique_ptr<BYTE []> ibuf(new BYTE[stride * i_hi]);
			if (FAILED(converter->CopyPixels(NULL, stride, stride*i_hi, ibuf.get()))) Abort();
			//rbg}bvɃRs[
			o_bmp->PixelFormat = pf24bit;
			o_bmp->SetSize(i_wd, i_hi);
			BYTE *bp = ibuf.get();
			for (unsigned int i=0; i<i_hi; i++, bp+=stride) ::CopyMemory(o_bmp->ScanLine[i], bp, stride);
		}
		catch (EAbort &e) {
			res = false;
		}
		catch (...) {
			res = false;
		}
	}
	__finally {
		::CoUninitialize();
	}
	return res;
}

//---------------------------------------------------------------------------
//摜̏kEg
//  i_bmp : ̓rbg}bv
//  o_bmp : o̓rbg}bv
//
//	ratio : {		0.0 : 
//   s_wd : TCY	  0 : 
//   s_hi : cTCY
//			{TCŶꂩw
//   s_opt: ASY
//---------------------------------------------------------------------------
bool WIC_resize_image(Graphics::TBitmap *i_bmp, Graphics::TBitmap *o_bmp,
	double ratio, unsigned int s_wd, unsigned int s_hi, int s_opt)
{
	if (ratio<=0.0 && (s_wd==0 || s_hi==0)) return false;

	bool res = true;
	try {
		::CoInitialize(NULL);
		try {
			TComInterface<IWICImagingFactory>	factory;
			TComInterface<IWICBitmap>			bitmap;
			TComInterface<IWICBitmapScaler> 	scaler;

			if (FAILED(::CoCreateInstance(CLSID_WICImagingFactory, NULL,
				CLSCTX_INPROC_SERVER, IID_IWICImagingFactory, (LPVOID*)&factory)))
					Abort();

			//\[Xrbg}bv쐬
			i_bmp->PixelFormat = pf24bit;
			if (FAILED(factory->CreateBitmapFromHBITMAP(
				i_bmp->Handle, NULL, WICBitmapIgnoreAlpha, &bitmap)))
					Abort();

			if (FAILED(factory->CreateBitmapScaler(&scaler))) Abort();

			//TCY
			UINT i_wd, i_hi;
			if (ratio>0) {
				i_wd = i_bmp->Width  * ratio;
				i_hi = i_bmp->Height * ratio;
			}
			else {
				i_wd = s_wd;
				i_hi = s_hi;
			}
			WICBitmapInterpolationMode opt;
			switch (s_opt) {
			case 1:  opt = WICBitmapInterpolationModeLinear; break;		//oCjA
			case 2:  opt = WICBitmapInterpolationModeCubic;	 break;		//oCL[rbN
			case 3:  opt = WICBitmapInterpolationModeFant;	 break;		//t@gTvO
			default: opt = WICBitmapInterpolationModeNearestNeighbor;	//ŋߖT@
			}
			if (FAILED(scaler->Initialize(bitmap, i_wd, i_hi, opt)))
				Abort();

			//C[WɃRs[
			UINT stride = i_wd * 3;
			std::unique_ptr<BYTE []> ibuf(new BYTE[stride * i_hi]);
			if (FAILED(scaler->CopyPixels(NULL, stride, stride*i_hi, ibuf.get()))) Abort();
			//rbg}bvɃRs[
			o_bmp->PixelFormat = pf24bit;
			o_bmp->SetSize(i_wd, i_hi);
			BYTE *bp = ibuf.get();
			for (unsigned int i=0; i<i_hi; i++, bp+=stride) ::CopyMemory(o_bmp->ScanLine[i], bp, stride);
		}
		catch (EAbort &e) {
			res = false;
		}
		catch (...) {
			res = false;
		}
	}
	__finally {
		::CoUninitialize();
	}
	return res;
}
//---------------------------------------------------------------------------
